;*********Procedure af2_version version 1_0*****************
;Procedure:af2_version
;Function:Test the IDL, pipeline and third-party routines installation****
;
;Option:  af2_version,file=xxx write version data to  file xxx
;         where xxx is the  file name including path
;
;Input   :None
;
;
;Example:
; af2_version,file='log_after_install_v2.txt'
;
;Procedures called: NONE

pro af2_version , FILE=file

current_version='3.0'

is_ok=file_which('read_control.pro')
if strlen(is_ok) eq 0 then print, 'No pipeline found! Check your !IDL_PATH'
if strlen(is_ok) eq 0 then return

;***************read the control file in the current directory of other path**************
if keyword_set(file) then begin
;***if file keyword is set, then use it as name (with path) of output test log***;
vl=file
endif else begin
vl='version_check.txt'
endelse
print, 'Test log file: '+strtrim(vl,2)

FILE_DELETE,vl



;*********************check working pipeline directory*****************;
;* it looks for a basic routine in pipeline project and find its path *;
pip_adr=''
this_file=strtrim('read_control.pro',2)
adr1 = strtrim(FILE_WHICH(this_file, /INCLUDE_CURRENT_DIR),2)
if strlen(adr1) ge strlen(this_file) then begin
pip_adr=strmid(adr1, 0,(strlen(adr1)-strlen(this_file)))
endif else begin
print, 'Error: No pipeline found! Please check you IDL settings'
endelse
if strlen(adr1) lt strlen(this_file) then return



;;*******define a working array for error messages***********;
err=['']
printl, vl, ' '
printl, vl, ' '


printl, vl, '---------------------------------------------------'
printl, vl, '              My IDL installation                  '
printl, vl, '---------------------------------------------------'
printl, vl, 'IDL Version: '+strtrim(!version.release,2)

printl, vl, 'ARCH: '+strtrim(!version.arch,2)
printl, vl, 'OS: '+strtrim(!version.os,2)
printl, vl, 'OS FAMILY: '+strtrim(!version.os_family,2)
printl, vl, 'OS NAME: '+strtrim(!version.os_name,2)
printl, vl, '---------------------------------------------------'
printl, vl, '               AF2 Pipeline status                 '
printl, vl, '---------------------------------------------------'

printl, vl, 'Which version of AF2 Pipeline am I using ? '+current_version
printl, vl, 'From where ?'
printl, vl, pip_adr


printl, vl, ' '
;printl, vl, 'Current working Directory'
;printl, vl, c.pdir
;printl, vl, ' '
;printl, vl, 'Current Data Directory'
;printl, vl, c.pdata
;printl, vl, ' '
printl, vl, '---------------------------------------------------'
printl, vl, '        Third-party routines (Required)            '
printl, vl, '---------------------------------------------------'

af2_libs=['atv.pro', 'write_gif.pro','af2_mean.pro','af2_robust_poly_fit.pro',$
 'chebeval.pro','chebfit.pro' , 'match2.pro', 'mmm.pro','mpfit.pro', $
 'mpfit_cheb.pro','mpfitfun.pro', 'mpfitpeak.pro', 'path_sep.pro', $
 'resistant_mean.pro','robust_mean.pro','scrollwindow.pro', 'sigma_filter.pro' ,$
 'strnumber.pro', 'vwpca.pro','vwpca_djs_iterstat.pro','vwpca_svd.pro',$
 'vwpca_reconstruct.pro','cgplot.pro', 'djs_median.pro','interpol.pro',$
 'peaks.pro','robust_sigma.pro','poly.pro','poly_fit.pro','rob_checkfit.pro',$
 'im_fitcontinuum.pro','rebinw.pro','djs_median.pro','djs_mean.pro',$
 'findex.pro', 'bspline_iterfit.pro', 'find_npeaks.pro', 'func_fit.pro']



for i=0 , n_elements(af2_libs)-1 do begin
is_ok=file_which(af2_libs(i))
printl, vl, af2_libs(i)+':'
if strlen(is_ok) eq 0 then begin
printl, vl, '**** Not found! Check your !IDL_PATH****'
err=[err,[strtrim(af2_libs(i),2)+' Routine not found! Check your !IDL_PATH']]
endif
if strlen(is_ok) gt 0 then printl, vl , is_ok
printl, vl, ' '
endfor


printl, vl, ''
printl, vl, '---------------------------------------------------'
printl, vl, '        Third-party packages (Required)            '
printl, vl, '---------------------------------------------------'

af2_package=['coyote', 'astron']

for i=0 , n_elements(af2_package)-1 do begin
ava=strpos(!path, af2_package(i))
printl, vl, af2_package(i)+':'
if ava eq -1 then begin 
printl, vl, ' Not found! It seems you have not installed this package.'
printl, vl, ' Check your !IDL_PATH   '
err=[err,[strtrim(af2_package(i),2)+$
' Package not installed or it has been renamed. Check your !IDL_PATH']]
endif else begin
printl, vl , 'Installed'
endelse
printl, vl, ' '
endfor

printl, vl, '---------------------------------------------------'
printl, vl, 'Test complete! Check the log file ('+vl+')'
printl, vl, '---------------------------------------------------'
printl, vl, ' '
printl, vl, '****************** Version check summary ******************'
printl, vl, 'IDL version: '+strtrim(!version.release,2)
printl, vl, 'OS: '+strtrim(!version.os_name,2)
printl, vl, 'AF2 pipeline version: '+current_version
printl, vl, 'Running from: '+ pip_adr

printl, vl, ' '
printl, vl, '************** Errors and warnings ******************'

if (n_elements(err) eq 1) then printl, vl, 'Hooray! No Error or Warning found'
for i_err=0, n_elements(err)-1 do printl, vl, err(i_err)
printl, vl, ' '

printl, vl, '---------------------------------------------------'
printl, vl, ' '



end
