pro pca_fiber,nsky, mag, err, mag_pca, err_pca

read_control,c
printl,c.log,'RUNNING PROCEDURE:pca_offset' 
;*********create a matrix of offset spectra and related errors************ 
data=fltarr(c.nwl, nsky)
data_er=fltarr(c.nwl, nsky)
for i=0, nsky-1 do begin
data(*,i)=transpose(mag(i,*))
data_er(*,i)=transpose(err(i,*))
endfor


printl,c.log,'PCA SKY MODE: SVD PCA  (sky fibers)'
;************* RUN PCA ALGORITHM ON OFFSET DATA****************************
;;-- number of PC amplitudes to calculate
namplitudes = 9
variances = 0 & evalues = 0 & pcs = 0 & espec = 0 & meanarr = 0
params = {niter:20, nevec:18,nobj_init:10}
espec = vwpca(data,namplitudes,variances,pcs,meanarr,evalues,/svd,params=params)
; print, 'Top 10 variances (approx): ',variances[0:9],form='(A18,10(F0.4,1X))'
; print, 'Top 10 evalues  : ',evalues[0:9],form='(A18, 10(F0.4,1X))'


;*************Create new matrix holding result of PCA method ******************
mag_pca=fltarr(c.nwl, nsky)
for i=0, nsky-1 do begin
mag_pca(*,i)=(vwpca_reconstruct(pcs[*,i],espec[*,0:namplitudes-1])+meanarr)
endfor

mag_pca=transpose(mag_pca)
err_pca=err

end