;*********Procedure star_check version 1_0*****************
;Procedure:star_check
;Function:Take the fiber number in idl console and Visualize
;the results of star routine for that fiber to check the 
;quality of Sky subtraction or wavelength calibration.
;
;Option:  star_check, wscl=wscl
; wscl parameter is used to scale the output window,
; allows user to precisely check the plots
;
;Input   :None
;
;
;Example:
; star_check, wscl=n (n is an integer number)
; then enter a fiber number to see the result or enter -1 to exit.
; wscl=n change the graphical output scale
;
;Procedures called: NONE
;
;
;****************************Procedure************************************
pro star_check, wscl=wscl
;id=2
;***************Read control data in structure c**************************
read_control,c
printl,c.log,'RUNNING PROCEDURE:star_check'
;;;**************set graphical window*****************
DEVICE, DECOMPOSED = 0
if keyword_set(wscl) then begin
;***if file keyword is set, then scale the plot window***;
scrollwindow,xsize=fix(wscl*(c.psize*1.3)), ysize=fix(wscl*(fix(c.psize/1.5)))
!p.charsize=wscl*2.0
endif else begin
scrollwindow,xsize=fix(c.psize*1.3), ysize=fix(c.psize/1.5)
!p.charsize=2.0
endelse

!P.MULTI=[0,1,3]
!x.charsize=1.4
!y.charsize=1.4
!x.thick=2
!y.thick=2
!p.charthick=1.5

;********************read spectra on common wavelength base***************
;********set observation type 'p' for output type spectra of star*********
;*Read output spectra of first of the starfiles (page 1 mag/ page 2 err)
   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,ff,mag,page=0
   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,err,page=1
   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,mag_raw,page=2
   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,err_raw,page=3
   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,mag_sky,page=4
   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,err_sky,page=5  

;;;;::::::::::::::::::;;;;for result of Medan;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  read_file,c.pdir+c.pspec+'q'+strtrim(c.starfile,2),cc,h,f,magq,page=0
;  read_file,c.pdir+c.pspec+'q'+strtrim(c.starfile,2),cc,h,f,errq,page=1


xxx =1
while xxx ne (-1) do begin
id=xxx
if (id lt 160) and (id gt 0) then begin


title1='!17Fibre No. '+strtrim(id, 2)+ ' (TYPE: '+strtrim(ff(id-1).type,2)+')'+$
 ' -- Black: Raw Spectrum   Red: RAW Sky'+$
 ' (TYPE: '+strtrim(ff(id-1).type,2)+')!3'
 ;, xrange=[8600.0, 9000.0], xstyle=1

title2='!17Fibre No. '+strtrim(id, 2)+' -- Black: Raw Spectrum   Red: SCALED Sky'+$
 ' (RAW/SKY Scale='+strtrim(ff(id-1).sky,2)+')!3';, xrange=[8600.0, 9000.0], xstyle=1

 title3='!17Fibre No. '+strtrim(id, 2)+' -- Sky Subtracted Spectrum!3'
 ;, xrange=[8600.0, 9000.0], xstyle=1




plot, mag_raw(0,*), mag_raw(id,*),title=title1,$
xtitle = 'Wavelength (A)', ytitle ='electrons/pixel',color=c.black,background=-1
oplot, mag_raw(0,*), mag_sky(id,*), color=c.red

plot, mag_raw(0,*), mag_raw(id,*),title=title2,$
xtitle = 'Wavelength (A)', ytitle ='electrons/pixel',color=c.black,background=-1
oplot, mag_raw(0,*), (ff(id-1).sky)*mag_sky(id,*), color=c.red

plot, mag_raw(0,*), mag(id,*),title=title3,$
xtitle = 'Wavelength (A)', ytitle ='electrons/pixel',color=c.black,background=-1

print, '*******************Fiber No. '+strtrim(id, 2)+'**********************'
print, 'Type= '+strtrim(ff(id-1).type,2)
print, 'Raw/Sky Scale= '+strtrim(ff(id-1).sky,2)
print, '****************************************************'
print, ' '
;;;;::::::::::::::::::;;;;for result of Medan;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;cgplot, mag_raw(0,*), mag_raw(id,*), title='Black:Raw data  Red: Raw Sky'
;, xrange=[8600.0, 9000.0], xstyle=1
;cgplot, mag_raw(0,*), mag_sky(id,*), /overplot, color='red'
;cgplot, mag_raw(0,*), magq(id,*), title='Medan_result', xrange=[8600.0, 9000.0], xstyle=1

endif else begin
print, ''
print, 'Invalid Fiber Number!'
print, ''
endelse

READ, xxx, PROMPT='Enter Fiber Number or -1 to exit:'
endwhile

end   
   