;*********Procedure star_check version 1_0*****************
;Procedure:star_check
;Function:Take the fiber number in idl console and Visualize
;the results of star routine for that fiber to check the 
;quality of Sky subtraction or wavelength calibration.
;
;Option:  star_check, wscl=wscl
; wscl parameter is used to scale the output window,
; allows user to precisely check the plots
;
;Input   :None
;
;
;Example:
; star_check, wscl=n (n is an integer number)
; then enter a fiber number to see the result or enter -1 to exit.
; wscl=n change the graphical output scale
;
;Procedures called: NONE
;
;
;****************************Procedure************************************
pro star_check_marc
;id=2
;***************Read control data in structure c**************************
read_control,c
printl,c.log,'RUNNING PROCEDURE:star_check_marc'
;;;**************set graphical window*****************
DEVICE, DECOMPOSED = 0

!P.MULTI=[0,1,4]
!y.margin=[4.5,4.5]
!x.margin=[4,4.0]
!x.omargin=2
!y.omargin=4
!p.font = 0 
!p.charsize=1.1 
!p.thick = 1.3 
!x.thick = 1.3 
!y.thick = 1.3 
!z.thick = 1.3 

filename='/Users/alireza/projects/af2/projects/may15_deep/20150512/result.eps'
psopen,filename , /color  , xsize=21,ysize=29

;********************read spectra on common wavelength base***************
;********set observation type 'p' for output type spectra of star*********
;*Read output spectra of first of the starfiles (page 1 mag/ page 2 err)
;   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,ff,mag,page=0
;   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,err,page=1
;   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,mag_raw,page=2
;   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,err_raw,page=3
;   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,mag_sky,page=4
;   read_file,c.pdir+c.pspec+'p'+strtrim(c.starfile,2),cc,h,f,err_sky,page=5 


   read_file,c.pdir+c.pspec+'p'+'2232976',cc,h,ff,mag1,page=0
   read_file,c.pdir+c.pspec+'p'+'2232976',cc,h,f,err1,page=1
   read_file,c.pdir+c.pspec+'p'+'2232976',cc,h,f,mag_raw1,page=2
   read_file,c.pdir+c.pspec+'p'+'2232976',cc,h,f,err_raw1,page=3
   read_file,c.pdir+c.pspec+'p'+'2232976',cc,h,f,mag_sky1,page=4
   read_file,c.pdir+c.pspec+'p'+'2232976',cc,h,f,err_sky1,page=5 

   read_file,c.pdir+c.pspec+'p'+'2232979',cc,h,ff,mag2,page=0
   read_file,c.pdir+c.pspec+'p'+'2232979',cc,h,f,err2,page=1
   read_file,c.pdir+c.pspec+'p'+'2232979',cc,h,f,mag_raw2,page=2
   read_file,c.pdir+c.pspec+'p'+'2232979',cc,h,f,err_raw2,page=3
   read_file,c.pdir+c.pspec+'p'+'2232979',cc,h,f,mag_sky2,page=4
   read_file,c.pdir+c.pspec+'p'+'2232979',cc,h,f,err_sky2,page=5 
   
   read_file,c.pdir+c.pspec+'p'+'2232980',cc,h,ff,mag3,page=0
   read_file,c.pdir+c.pspec+'p'+'2232980',cc,h,f,err3,page=1
   read_file,c.pdir+c.pspec+'p'+'2232980',cc,h,f,mag_raw3,page=2
   read_file,c.pdir+c.pspec+'p'+'2232980',cc,h,f,err_raw3,page=3
   read_file,c.pdir+c.pspec+'p'+'2232980',cc,h,f,mag_sky3,page=4
   read_file,c.pdir+c.pspec+'p'+'2232980',cc,h,f,err_sky3,page=5 
   
   read_file,c.pdir+c.pspec+'p'+'2232981',cc,h,ff,mag4,page=0
   read_file,c.pdir+c.pspec+'p'+'2232981',cc,h,f,err4,page=1
   read_file,c.pdir+c.pspec+'p'+'2232981',cc,h,f,mag_raw4,page=2
   read_file,c.pdir+c.pspec+'p'+'2232981',cc,h,f,err_raw4,page=3
   read_file,c.pdir+c.pspec+'p'+'2232981',cc,h,f,mag_sky4,page=4
   read_file,c.pdir+c.pspec+'p'+'2232981',cc,h,f,err_sky4,page=5 
 

;;;;::::::::::::::::::;;;;for result of Medan;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  read_file,c.pdir+c.pspec+'q'+strtrim(c.starfile,2),cc,h,f,magq,page=0
  read_file,c.pdir+c.pspec+'q'+strtrim(c.starfile,2),cc,h,f,errq,page=1
help, mag
help, magq


;FMT = 'I,A'
;READCOL,'/Users/alireza/projects/af2/projects/may15_deep/20150512/target.cat',F=FMT, obid, descrp ,DELIMITER=';;;' 


target=rsex('target.cat')

fid_test=[0,0]
for id=1 , 160 do begin
if strtrim(ff(id-1).type,2) eq 'P' then begin
;title1='!17Fibre No. '+strtrim(id, 2)+ ' (TYPE: '+strtrim(ff(id-1).type,2)+')'+$
; ' -- Black: Raw Spectrum   Red: RAW Sky'+$
; ' (TYPE: '+strtrim(ff(id-1).type,2)+')!3'
; ;, xrange=[8600.0, 9000.0], xstyle=1
;
;title2='!17Fibre No. '+strtrim(id, 2)+' -- Black: Raw Spectrum   Red: SCALED Sky'+$
; ' (RAW/SKY Scale='+strtrim(ff(id-1).sky,2)+')!3';, xrange=[8600.0, 9000.0], xstyle=1
;
; title3='!17Fibre No. '+strtrim(id, 2)+' -- Sky Subtracted Spectrum!3'
; ;, xrange=[8600.0, 9000.0], xstyle=1
;
;
;
;
;plot, mag_raw(0,*), mag_raw(id,*),title=title1,$
;xtitle = 'Wavelength (A)', ytitle ='electrons/pixel',color=c.black,background=-1
;oplot, mag_raw(0,*), mag_sky(id,*), color=c.red
;
;plot, mag_raw(0,*), mag_raw(id,*),title=title2,$
;xtitle = 'Wavelength (A)', ytitle ='electrons/pixel',color=c.black,background=-1
;oplot, mag_raw(0,*), (ff(id-1).sky)*mag_sky(id,*), color=c.red
;
;plot, mag_raw(0,*), mag(id,*),title=title3,$
;xtitle = 'Wavelength (A)', ytitle ='electrons/pixel',color=c.black,background=-1
;
;print, '*******************Fiber No. '+strtrim(id, 2)+'**********************'
;print, 'Type= '+strtrim(ff(id-1).type,2)
;print, 'Raw/Sky Scale= '+strtrim(ff(id-1).sky,2)
;print, '****************************************************'
;print, ' '
;;;;::::::::::::::::::;;;;for result of Medan;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

title1='Fiber no.'+strcompress(string(id),/remove_all)+'  '+'RAW DATA'
title2='Fiber no.'+strcompress(string(id),/remove_all)+'  '+'RAW DATA (SKY OVERPLOTED)'
title3='Fiber no.'+strcompress(string(id),/remove_all)+'  '+'Sky Subtracted Data'
title4='Fiber no.'+strcompress(string(id),/remove_all)+' [COADDED DATA (MEDIAN)]'+'  '+ $
'Name= '+strcompress(string(target(where(target.oid eq id)).name),/remove_all)+ $
'  Mag= '+strcompress(string(target(where(target.oid eq id)).mag),/remove_all)+ $
'  Priority= '+strcompress(string(target(where(target.oid eq id)).pr),/remove_all)



cgplot, mag_raw1(0,*), mag_raw1(id,*), title=title1 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'
cgplot, mag_raw1(0,*), mag_raw1(id,*), title=title2 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'
cgplot, mag_raw1(0,*), mag_sky1(id,*), /overplot, color='red'
cgplot, mag_raw1(0,*), mag1(id,*), title=title3 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'
;cgplot, mag_raw1(0,*), mag2(id,*), title=title3 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'
;cgplot, mag_raw1(0,*), mag3(id,*), title=title3 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'
;cgplot, mag_raw1(0,*), mag4(id,*), title=title3 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'

mm=mag_raw1(id,*)
ww=mag_raw1(0,*)
sum1=mean(abs(mm(where(ww ge 6600 and ww le 6750))))
mg1=target(where(target.oid eq id)).mag

fid_test=[[fid_test],[mg1,sum1]]


all=[[transpose(mag1(id,*))],[transpose(mag2(id,*))],[transpose(mag3(id,*))*1.63636],[transpose(mag4(id,*))]]

med=median(all, dimension=2)
cgplot, mag_raw1(0,*), transpose(med), title=title4 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'


;if max(magq(id,*)) lt 1.0 then begin
;cgplot, mag_raw1(0,*), mag1(id,*), title=title3 , xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'
;endif else begin
;cgplot, mag_raw1(0,*), magq(id,*), title=title4, xrange=[6000.0, 9025.0], xstyle=1, xticks=12, xtitle='wavelength'
;endelse

endif
endfor

psclose
pstopdf, filename

!P.MULTI=[0,1,1]
!y.margin=[4.5,4.5]
!x.margin=[4,4.0]
!x.omargin=2
!y.omargin=4
!p.font = 0 
!p.charsize=1.1 
!p.thick = 1.3 
!x.thick = 1.3 
!y.thick = 1.3 
!z.thick = 1.3 
filename='/Users/alireza/projects/af2/projects/may15_deep/20150512/fid_result.eps'
psopen,filename , /color  , xsize=21,ysize=21
cgplot, fid_test[0,*],fid_test[1,*],psym=15, xrange=[18.5,21.5], xstyle=1, xtitle='Magnitude', ytitle='Mean(output)  [6600 < WL < 6750]', title='Test'
psclose
pstopdf, filename


end   
   